'Scan a 160*144 PCX file and convert it to GameBoy Byte cells.
'by: Thorleif Bundgaard <navico@krull.dk>
'(NOTE: PCX must be exactly 160*144)
'this source will compile using QBASIC or Quick Basic
'This source is public domain
'-------------------------------------------------------------------
'Byte Bytes Typic Name
' 0    1      0A  Creator      Always 10=Zsoft
' 1    1      05  Version      PCX Version
'                              0 = V2.5
'                              2 = V2.8 With color palette
'                              3 = V2.8 Without color palette
'                              5 = V3.0 With color palette
' 2    1      01  Encoding     1 = Runlength coding
' 3    1      08  Bits         No of bits per pixel and colorplane
'                              CGA LoRes + VGA with 256 colors: 2 bits
'                              All others: 1 bit per pixel
' 4   4*2  00 00  Xmin         Logical coordinates of the picture
'          00 00  Ymin
'          9F 00  Xmax
'          8F 00  Ymax
'12    2   80 02  Hres         Horizontal resolution of the source
'14    2   E0 01  Vres         Vertical resolution of the source
'16  16*3         Palette      Color palette 16 * (R, G, B)
'          47 05 00  00 9E 0B  94 2A 8D  71 B4 6B  B7 5E 94
'          2A 87 1B  50 6F 8D  71 10 6C  0E 0F 7F  1C 52 6C  87 1B 00
'          00 0C 00  94 2A 50  6F 8D 71  00 00 00  00 01 00
'64    1      00  Vmode        For internal paintbrush use             00
'65    1      01  Planes       No of color planes                      01
'                              EGA/VGA = 4  CGA/Hercules = 1
'66    2   0A 00  Byte/line    No of stored bytes per line, count only 40
'                              one color plane
'68    2   2F 04  Palette info Color interpretation                    01
'                              1=color(also Black/white)  2=Graylevels
'70   58          Filler       Filling untill 128 bytes
'          CC 7F 47 05 36 6C 87 1B 00 00 00 00 97 1D FC 6B 06 01 9F 1D
'          36 6C 87 1B 00 00 00 00 F4 26 48 4B 39 15 FF 1D 00 00 87 1B
'          31 6C 94 80 47 05 36 6C 87 1B 00 00 00 00 EF 17 F4 26
'128   ?          PCX data
'      FF 07 FF 07 E2 07        A gray line
'      FF 07 FF 07 E2 07        A gray line
'      FF 00 FF 00 E2 00        A black line
'      EC FF E4 00 FF FF D1 FF  White / black / white
'      EC FF E5 00 FF FF D0 FF  etc.
'-------------------------------------------------------------------
Wrong1 = 18  'Numbers of wrong colors, in order to identify them
Wrong2 = 19
Wrong3 = 63
Wrong4 = 127

SCREEN 0, 0, 0: CLS


FILES "*.pcx"
INPUT "Filename: (No extension) ", FILE$
IF FILE$ = "" THEN FILE$ = "GBCOLOR2"
OPEN FILE$ + ".PCX" FOR BINARY AS #1

DIM B AS STRING * 1

ON ERROR GOTO 0

N = 66 + 1: GET #1, N, B: BPL = ASC(B)
N = 67 + 1: GET #1, N, B: BPL = BPL + 256 * ASC(B)'Bytes per line

N = 8 + 1: GET #1, N, B: Xm = ASC(B)
N = 9 + 1: GET #1, N, B: Xm = Xm + 256 * ASC(B)'Xmax

N = 10 + 1: GET #1, N, B: Ym = ASC(B)
N = 11 + 1: GET #1, N, B: Ym = Ym + 256 * ASC(B)'Ymax

PRINT "X = 0 -"; Xm, "Y = 0 -"; Ym, BPL; " Bytes per line"
Xmax = 160: Ymax = 144 'pen 0-3
Xmax = Xm: Ymax = Ym + 1
INPUT "Press Enter:"; s
SCREEN 13 'graphic screen 320*200

'* Draw frame around screen in 0-319 0-199

LINE (0, 0)-(161, 0), 14:     'xaxis
LINE (0, 145)-(161, 145), 14: 'xaxis
LINE (0, 0)-(0, 145), 14:     'yaxis
LINE (161, 0)-(161, 145), 14: 'yaxis

LOCATE 1, 22: PRINT "Color in use:"
LOCATE 2, 22: PRINT "0123456789ABCDEF"
FOR Fx = 0 TO 15
  FOR Fy = 0 TO 15
   LOCATE Fy + 3, Fx + 22: PRINT "+"
  NEXT Fy
NEXT Fx

FOR N = 0 TO 63: PSET (N + 50, 147), N: NEXT N
LOCATE 20, 4: PRINT FILE$


X = 1: Y = 1 'starting position

P = VAL("&H80") + 1
NewLine:
GetPix:
   CNT = 1
   GET #1, P, B: P = P + 1: Farve = ASC(B): B1 = Farve
   IF (Farve AND VAL("&HC0")) = VAL("&HC0") THEN
      CNT = Farve AND VAL("&H3F")
      GET #1, P, B: P = P + 1: Farve = ASC(B): B2 = Farve
   END IF
      cFarve = 9: CF = 0                          'Blue   Unknown color
      IF Farve = Wrong1 THEN cFarve = 11: CF = 0  'Cyan     Wrong color
      IF Farve = Wrong2 THEN cFarve = 10: CF = 0  'Green    Wrong color
      IF Farve = Wrong3 THEN cFarve = 13: CF = 0  'Purple   Wrong color
      IF Farve = Wrong4 THEN cFarve = 14: CF = 0  'Yellow   Wrong color

      IF Farve = 255 THEN cFarve = 31: CF = 0  'White
        IF Farve = 7 THEN cFarve = 27: CF = 1  'Light Gray   Color 16-31
      IF Farve = 248 THEN cFarve = 21: CF = 2  'Dark Gray    gives gray scale
        IF Farve = 0 THEN cFarve = 17: CF = 3  'Black
 
   Fx = INT(Farve AND 15): Fy = INT(Farve / 16)
   LOCATE Fy + 3, Fx + 22
   COLOR cFarve: PRINT "*": COLOR 15
 
   FOR X = X TO X + CNT - 1
     PSET (X, Y), cFarve
   NEXT X

   IF X <= Xmax + 1 THEN GOTO GetPix
   X = 1
   Y = Y + 1
   IF Y < 144 THEN GOTO NewLine

CLOSE
   LOCATE 21, 20: PRINT "0 = Stop"
   LOCATE 22, 20: PRINT "1 = Chr font File "
   LOCATE 23, 20: INPUT "2 = Backdrop File ", Ft
   IF Ft = 0 THEN STOP

   Ot = 0
'   INPUT "Output file: 0=Hex  1=Screen ", Ot
   IF Ot = 0 THEN
      OPEN FILE$ + ".HEX" FOR OUTPUT AS #2
   ELSE
      OPEN "CON" FOR OUTPUT AS #2
   END IF

   SELECT CASE Ft
   CASE 1            '0=Character font
'Show limit for conversion to alfa
LINE (0, 129)-(161, 129), 14: 'xaxis
LINE (129, 0)-(129, 145), 14: 'yaxis
      PRINT #2, ";"; FILE$; ".PCX"
      PRINT #2, "  DB ";
      X = 0: Y = 0
      FOR CH = 0 TO 255
'LOCATE 19, 1: INPUT Q
        FOR rY = 0 TO 7
          vh = 0: vl = 0
          FOR rX = 0 TO 7
            P = POINT((X + 1) + rX, (Y + 1) + rY)
PSET ((X + 1) + rX, (Y + 1) + rY), 12
               IF P = 31 THEN CF = 0   'White
               IF P = 27 THEN CF = 1   'Light Gray
               IF P = 21 THEN CF = 2   'Dark Gray
               IF P = 17 THEN CF = 3   'Black
            IF (CF AND 1) = 1 THEN vl = vl OR 2 ^ (7 - rX)
            IF (CF AND 2) = 2 THEN vh = vh OR 2 ^ (7 - rX)
          NEXT rX
          V$ = "00" + HEX$(vh): V$ = RIGHT$(V$, 2)
          PRINT #2, "0"; V$; "H,";
          V$ = "00" + HEX$(vl): V$ = RIGHT$(V$, 2)
          PRINT #2, "0"; V$; "H,";
        NEXT rY
        PRINT #2, ""
        PRINT #2, "  DB ";
        X = X + 8
        IF X > (8 * 15) THEN X = 0: Y = Y + 8
      NEXT CH
      PRINT #2, ""
      CLOSE
      END

'     .db $00,$00,$00,$00,$00,$FF,$00,$FF,$FF,$00,$FF,$00,$FF,$FF,$FF,$FF
'     .db $10,$10,$38,$38,$6C,$6C,$C6,$C6,$FE,$FE,$C6,$C6,$C6,$C6,$00,$00
'     .db $FC,$FC,$C6,$C6,$C6,$C6,$FC,$FC,$C6,$C6,$C6,$C6,$FC,$FC,$00,$00
'     .db $7E,$7E,$C0,$C0,$C0,$C0,$C0,$C0,$C0,$C0,$C0,$C0,$7E,$7E,$00,$00
'     .db $FC,$FC,$C6,$C6,$C6,$C6,$C6,$C6,$C6,$C6,$C6,$C6,$FC,$FC,$00,$00

   CASE 2            '1=Graphic backdrop
      PRINT #2, ";"; FILE$; ".PCX"
      PRINT #2, "  DB ";
      X = 0: Y = 0
      PRINT #2, ""
      CLOSE

   CASE ELSE
   END SELECT


END

LineStart:
        PRINT #2, ""
        PRINT #2, " DB ";
        RETURN
WriteHex:
        SELECT CASE Ft
        CASE 0            '0=Character font
           bi = (X - 1) MOD 8
             IF (CF AND 1) = 1 THEN vh = vh OR 2 ^ bi
             IF (CF AND 2) = 2 THEN vl = vl OR 2 ^ bi
           IF bi = 7 THEN
             V$ = "00" + HEX$(vh): V$ = RIGHT$(V$, 2)
             PRINT #2, "0"; V$; "H,";
             V$ = "00" + HEX$(vl): V$ = RIGHT$(V$, 2)
             PRINT #2, "0"; V$; "H,";
             vh = 0: vl = 0
           END IF

'     .db $00,$00,$00,$00,$00,$FF,$00,$FF,$FF,$00,$FF,$00,$FF,$FF,$FF,$FF
'     .db $10,$10,$38,$38,$6C,$6C,$C6,$C6,$FE,$FE,$C6,$C6,$C6,$C6,$00,$00
'     .db $FC,$FC,$C6,$C6,$C6,$C6,$FC,$FC,$C6,$C6,$C6,$C6,$FC,$FC,$00,$00
'     .db $7E,$7E,$C0,$C0,$C0,$C0,$C0,$C0,$C0,$C0,$C0,$C0,$7E,$7E,$00,$00
'     .db $FC,$FC,$C6,$C6,$C6,$C6,$C6,$C6,$C6,$C6,$C6,$C6,$FC,$FC,$00,$00

        CASE 1            '1=Graphic backdrop
           V$ = HEX$(CF): V$ = RIGHT$(V$, 1)
           PRINT #2, V$; ",";
        CASE ELSE
        END SELECT
        RETURN
FileEnd:
        PRINT #2, ""
        RETURN

